unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Menus, UnitDefs;

type
  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    BtnConnect: TButton;
    GroupBox6: TGroupBox;
    BtnSetSCL: TButton;
    EditSCL: TEdit;
    PlSCLFreq: TPanel;
    BtnGetSCLFreq: TButton;
    GroupBox1: TGroupBox;
    EditSlvAdr: TEdit;
    BtnSetSlvAdr: TButton;
    PLSlvAdr: TPanel;
    BtnChkSlvAdr: TButton;
    PlChkSlvAdr: TPanel;
    GroupBox4: TGroupBox;
    BtnWrite: TButton;
    EditWrite: TEdit;
    BtnRead: TButton;
    EditRead: TEdit;
    UpDown1: TUpDown;
    GroupBox3: TGroupBox;
    MemoLog: TMemo;
    StatusBar: TStatusBar;
    COMPopUp: TPopupMenu;
    COM11: TMenuItem;
    COM21: TMenuItem;
    COM31: TMenuItem;
    COM41: TMenuItem;
    GroupBox7: TGroupBox;
    BtnSetDIP: TButton;
    EditCon: TEdit;
    BtnIO0: TButton;
    BtnGetIO: TButton;
    BtnIO1: TButton;
    procedure WndProc(var Message: TMessage); override;
    procedure COMClick(Sender: TObject);
    procedure EditSlvAdrKeyPress(Sender: TObject; var Key: Char);
    procedure EditSCLKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure BtnConnectClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnSetSlvAdrClick(Sender: TObject);
    procedure BtnChkSlvAdrClick(Sender: TObject);
    procedure BtnSetSCLClick(Sender: TObject);
    procedure BtnGetSCLFreqClick(Sender: TObject);
    procedure BtnWriteClick(Sender: TObject);
    procedure BtnReadClick(Sender: TObject);
    procedure BtnSetDIPClick(Sender: TObject);
    procedure BtnIO0Click(Sender: TObject);
    procedure BtnIO1Click(Sender: TObject);
    procedure BtnGetIOClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DezKey(var Key: Char);
    procedure HexKey(var Key: Char);
  end;

var
  Form1     : TForm1;
  StrLog    : String;
  IOState0  : Boolean;
  IOState1  : Boolean;

implementation

{$R *.DFM}

procedure TForm1.COMClick(Sender: TObject);
begin
  (Sender AS TMenuItem).Checked := true;
  SetComPort((Sender AS TMenuItem).MenuIndex + 1);
end;

procedure TForm1.DezKey(var Key: Char);
begin
  if not (Key in [#8,#13,'0','1','2','3','4','5','6','7','8','9']) then Key := #0;
end;

procedure TForm1.HexKey(var Key: Char);
begin
  if Key = 'a' then Key := 'A';
  if Key = 'b' then Key := 'B';
  if Key = 'c' then Key := 'C';
  if Key = 'd' then Key := 'D';
  if Key = 'e' then Key := 'E';
  if Key = 'f' then Key := 'F';
  if not (Key in [#8,#13,'0','1','2','3','4','5','6','7','8','9',
                  'A','B','C','D','E','F']) then Key := #0;
end;

procedure TForm1.EditSlvAdrKeyPress(Sender: TObject; var Key: Char);
begin
  HexKey(Key);
end;

procedure TForm1.EditSCLKeyPress(Sender: TObject; var Key: Char);
begin
  DezKey(key);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DIPSwitch := StrToInt('$'+EditCon.Text);
  wPrivateMsg := SerI2CCreate;
  SlvAdr   := 0;
  PLSlvAdr.Caption := '0x'+IntToHex(SlvAdr,2);
  IOState0 := false;
  IOState1 := false;
  if GetComport = 0 then SetComport(1);
  COMPopUp.Items.MenuIndex := GetComport - 1;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SerI2CDestroy;
end;

procedure TForm1.BtnConnectClick(Sender: TObject);
begin
  if Bool(IsConnected) then Connect(0)
  else Connect(1);
end;

procedure TForm1.WndProc(var Message: TMessage);
var i, len : integer;
begin
  if (Message.Msg = wPrivateMsg) then
  begin
    case Message.WParam of
    MSGReadI2CTOut   : begin
                         Statusbar.Panels[0].Text := 'ERROR - R TimeOut';
                         Statusbar.Panels[1].Text := '';
                       end;
    MSGWriteI2CTOut  : begin
                         Statusbar.Panels[0].Text := 'ERROR - W TimeOut';
                         Statusbar.Panels[1].Text := '';
                       end;
    MSGReadResponse  : begin
                         case Message.LParamLo of
                         0 : MessageDlg('unkown I2C-Device!',mtERROR, [mbOK], 0);
                         1 : begin
                               I2CData := GetI2CData;
                               Len := I2CData.iLen;
                               StrLog := '['+IntToHex(I2CData.iDIP,2)+'] '+
                                         '['+IntToHex(I2CData.iSlvAdr,2)+'] '+
                                         '[R] ';
                               For i := 0 to Len-1 do
                                 StrLog := StrLog + '['+IntToHex(I2CData.iData[i],2)+'] ';
                               MemoLog.Lines.Add(StrLog);
                               Statusbar.Panels[1].Text := IntToHex(I2CData.iDIP,2)+
                                                           ' '+IntToHex(I2CData.iSlvAdr,2);
                             end;
                         end;
                       end;
    MSGWriteResponse : begin
                         case Message.LParamLo of
                         0 : MessageDlg('unkown I2C-Device!',mtERROR, [mbOK], 0);
                         1 : begin
                               Statusbar.Panels[0].Text := 'Write-CMD executed';
                               Statusbar.Panels[1].Text := IntToHex(Byte(Message.LParamHi shr 8),2)+
                                                           ' '+IntToHex(Byte(Message.LParamHi),2);
                               MemoLog.Lines.Add(StrLog);
                             end;
                         end;
                       end;

    MSGIO1           : begin
                         case (Message.LParamLo AND $01) of
                         0: begin
                              IOState0 := True;
                              BtnIO0.Caption := 'IO.0 "0"';
                            end;
                         1: begin
                              IOState0 := False;
                              BtnIO0.Caption := 'IO.0 "1"';
                            end;
                         end;
                         Statusbar.Panels[1].Text := IntToHex(Message.LParamHi,2);
                       end;
    MSGIO2           : begin
                         case (Message.LParamLo AND $01) of
                         0: begin
                              IOState1 := True;
                              BtnIO1.Caption := 'IO.1 "0"';
                            end;
                         1: begin
                              IOState1 := False;
                              BtnIO1.Caption := 'IO.1 "1"';
                            end;
                         end;
                         Statusbar.Panels[1].Text := IntToHex(Message.LParamHi,2);
                       end;
    MSGIO            : begin
                         case (Message.LParamLo AND $01) of
                         0: begin
                              IOState0 := True;
                              BtnIO0.Caption := 'IO.0 "0"';
                            end;
                         1: begin
                              IOState0 := False;
                              BtnIO0.Caption := 'IO.0 "1"';
                            end;
                         end;
                         case (Message.LParamLo AND $02) of
                         0: begin
                              IOState1 := True;
                              BtnIO1.Caption := 'IO.1 "0"';
                            end;
                         2: begin
                              IOState1 := False;
                              BtnIO1.Caption := 'IO.1 "1"';
                            end;
                         end;
                         Statusbar.Panels[1].Text := IntToHex(Message.LParamHi,2);
                       end;

    MSGSCLFreq       : begin
                         PlSCLFreq.Caption := IntToStr(Message.LParamLo) + ' kHz';
                         Statusbar.Panels[1].Text := IntToHex(Message.LParamHi,2);
                       end;
    MSGSCLChange     : begin
                         PlSCLFreq.Caption := IntToStr(Message.LParamLo)  + ' kHz';
                         Statusbar.Panels[1].Text := IntToHex(Message.LParamHi,2);
                       end;
    MSGComOpen       : begin
                         BtnConnect.Caption := 'COM'+IntToStr(Message.LParam);
                         Statusbar.Panels[0].Text := 'COMPort '+
                                                     IntToStr(Message.LParam)+
                                                     ' open';
                       end;
    MSGComClose      : begin
                         BtnConnect.Caption := 'COM?';
                         Statusbar.Panels[0].Text := 'COMPort '+
                                                     IntToStr(Message.LParam)+
                                                     ' closed';
                       end;
    MSGDVer          : begin
                         MemoLog.Lines.Add(GetVersion);
                         Statusbar.Panels[1].Text := IntToHex(Message.LParam,2);
                       end;
    MSGCSlave        : begin
                         case Message.LParamLo of
                         0: PlChkSlvAdr.Caption := 'BAD';
                         1: PlChkSlvAdr.Caption := 'OK';
                         end;
                         Statusbar.Panels[1].Text := IntToHex(Byte(Message.LParamHi shr 8),2);
                         Statusbar.Panels[0].Text := '0x'+IntToHex(Byte(Message.LParamHi),2)+
                         ' checked';
                       end;
    MSGCSErr         : begin
                         Statusbar.Panels[0].Text := 'CheckSum ERROR';
                         Statusbar.Panels[1].Text := IntToHex(Message.LParam,2);
                       end;
    MSGUnknownCMD    : begin
                         Statusbar.Panels[0].Text := 'unknown command';
                         Statusbar.Panels[1].Text := IntToHex(Message.LParam,2);
                       end;
    end;
  end;
  inherited WndProc(Message); { geerbte Botschaftsbehandlungsmethode }
end;

procedure TForm1.BtnSetSlvAdrClick(Sender: TObject);
var SAdr : Byte;
begin
  SAdr := StrToInt('$'+EditSlvAdr.Text);
  if (SAdr AND $01) = $01 then MessageDlg('Invalid Slave Address!',mtERROR, [mbOK], 0)
  else begin
    SlvAdr    := SAdr;
    PlSlvAdr.Caption := '0x'+IntToHex(SlvAdr,2);
  end;
end;

procedure TForm1.BtnSetDIPClick(Sender: TObject);
begin
  DIPSwitch := StrToInt('$'+EditCon.Text);
end;

procedure TForm1.BtnChkSlvAdrClick(Sender: TObject);
begin
  case CheckSlvAdr(DIPSwitch,SlvAdr) of
    0 : Statusbar.Panels[0].Text := 'Write_CMD';
    1 : Statusbar.Panels[0].Text := 'ERROR: COMPORT CLOSED' ;
    2 : Statusbar.Panels[0].Text := 'Adapter is BUSY';
    3 : Statusbar.Panels[0].Text := 'Invalid Slave Adr.';
  end;
end;

procedure TForm1.BtnSetSCLClick(Sender: TObject);
begin
  case SetSCLCLk(DIPSwitch,StrToInt(EditSCL.Text)) of
    0: Statusbar.Panels[0].Text := 'Send SCL CMD' ;
    1: Statusbar.Panels[0].Text := 'ERROR: COMPORT CLOSED';
    2: Statusbar.Panels[0].Text := 'Adapater is Busy';
    3: Statusbar.Panels[0].Text := 'Invalid Bit Frequency';
  end;
end;

procedure TForm1.BtnGetSCLFreqClick(Sender: TObject);
begin
  case RequestSCLFreq(DIPSwitch) of
    0: Statusbar.Panels[0].Text := 'SCL-Freq requested' ;
    1: Statusbar.Panels[0].Text := 'ERROR: COMPORT CLOSED';
    2: Statusbar.Panels[0].Text := 'Adapter is Busy';
  end;
end;

procedure TForm1.BtnWriteClick(Sender: TObject);
var sData : String;
    iData : Array of Byte;
    i,k   : Byte;
    Len   : Integer;
begin
  sData := EditWrite.Text;
  Len   := Length(sData);
  SetLength(iData, Len DIV 2);
  k := 0;
  i := 1;
  StrLog := '['+IntToHex(DIPSwitch,2)+'] ['+IntToHex(SlvAdr,2)+'] [W] ';
  While i <= Len - 1 do
  begin
    iData[k] := StrToInt('$'+Copy(sData,i,2));
    StrLog := StrLog + '['+Copy(sData,i,2)+'] ';
    i := i + 2;
    inc(k);
  end;
  case WriteI2C(DIPSwitch,SlvAdr,iData) of
    0 : Statusbar.Panels[0].Text := 'Send WRITE CMD';
    1 : Statusbar.Panels[0].Text := 'ERROR: COMPORT CLOSED' ;
    2 : Statusbar.Panels[0].Text := 'Adapter is Busy';
  end;
end;

procedure TForm1.BtnReadClick(Sender: TObject);
var Cnt : Byte;
begin
  Cnt := StrToInt(EditRead.Text);
  case ReadI2C(DIPSwitch,SlvAdr,Cnt) of
    0: Statusbar.Panels[0].Text := 'Send READ CMD' ;
    1: Statusbar.Panels[0].Text := 'ERROR: COMPORT CLOSED' ;
    2: Statusbar.Panels[0].Text := 'Adapter is Busy';
  end;
end;

procedure TForm1.BtnIO0Click(Sender: TObject);
begin
  case ReSetIO(DIPSwitch,0,Integer(IOState0)) of
    0: Statusbar.Panels[0].Text := 'Send IO.0 CMD' ;
    1: Statusbar.Panels[0].Text := 'ERROR: COMPORT CLOSED';
    2: Statusbar.Panels[0].Text := 'Adapater is Busy';
  end;
end;

procedure TForm1.BtnIO1Click(Sender: TObject);
begin
  case ReSetIO(DIPSwitch,1,Integer(IOState1)) of
    0: Statusbar.Panels[0].Text := 'Send IO.1 CMD' ;
    1: Statusbar.Panels[0].Text := 'ERROR: COMPORT CLOSED';
    2: Statusbar.Panels[0].Text := 'Adapater is Busy';
  end;
end;

procedure TForm1.BtnGetIOClick(Sender: TObject);
begin
  case RequestIO(DIPSwitch) of
    0: Statusbar.Panels[0].Text := 'Request IO-State' ;
    1: Statusbar.Panels[0].Text := 'ERROR: COMPORT CLOSED';
    2: Statusbar.Panels[0].Text := 'Adapater is Busy';
  end;
end;

end.


